Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.joda.time
Class Days

    java.lang.Object
      org.joda.time.base.BaseSingleFieldPeriod
          org.joda.time.Days

All Implemented Interfaces:
  java.io.Serializable, java.lang.Comparable, ReadablePeriod

    public final class Days

extends BaseSingleFieldPeriod

An immutable time period representing a number of days.

`Days` is an immutable period that can only store days. It does not store years, months or hours for example. As such it is a type-safe way of representing a number of days in an application.

The number of days is set in the constructor, and may be queried using `getDays()`. Basic mathematical operations are provided - `plus()`, `minus()`, `multipliedBy()` and `dividedBy()`.

`Days` is thread-safe and immutable.

Since:
  1.4
Author:
  Stephen Colebourne
See Also:
  Serialized Form

Field Summary
`static Days` | `FIVE` Constant representing five days.
`static Days` | `FOUR` Constant representing four days.
`static Days` | `MAX_VALUE` Constant representing the maximum nuber of days that can be stored in this object.
`static Days` | `MIN_VALUE` Constant representing the minimum nuber of days that can be stored in this object.
`static Days` | `ONE` Constant representing one day.
`static Days` | `SEVEN` Constant representing seven days.
`static Days` | `SIX` Constant representing six days.
`static Days` | `THREE` Constant representing three days.
`static Days` | `TWO` Constant representing two days.
`static Days` | `ZERO` Constant representing zero days.

Method Summary
`static Days` | `days(int days)` Obtains an instance of `Days` that may be cached.
`static Days` | `daysBetween(ReadableInstant start, ReadableInstant end)` Creates a `Days` representing the number of whole days between the two specified datetimes.
`static Days` | `daysBetween(ReadablePartial start, ReadablePartial end)` Creates a `Days` representing the number of whole days between the two specified partial datetimes.
`static Days` | `daysIn(ReadableInterval interval)` Creates a `Days` representing the number of whole days in the specified interval.
`Days` | `dividedBy(int divisor)` Returns a new instance with the days divided by the specified divisor.
`int` | `getDays()` Gets the number of days that this period represents.
`DurationFieldType` | `getFieldType()` Gets the duration field type, which is `days`.
`PeriodType` | `getPeriodType()` Gets the period type, which is `days`.
`boolean` | `isGreaterThan(Days other)` Is this days instance greater than the specified number of days.
`boolean` | `isLessThan(Days other)` Is this days instance less than the specified number of days.
`Days` | `minus(Days days)` Returns a new instance with the specified number of days taken away.
`Days` | `minus(int days)` Returns a new instance with the specified number of days taken away.
`Days` | `multipliedBy(int scalar)` Returns a new instance with the days multiplied by the specified scalar.
`Days` | `negated()` Returns a new instance with the days value negated.
`static Days` | `parseDays(java.lang.String periodStr)` Creates a new `Days` by parsing a string in the ISO8601 format 'PnD'.
`Days` | `plus(Days days)` Returns a new instance with the specified number of days added.
`Days` | `plus(int days)` Returns a new instance with the specified number of days added.
`static Days` | `standardDaysIn(ReadablePeriod period)` Creates a new `Days` representing the number of complete standard length days in the specified period.
`Duration` | `toStandardDuration()` Converts this period in days to a duration in milliseconds assuming a 24 hour day, 60 minute hour and 60 second minute.
`Hours` | `toStandardHours()` Converts this period in days to a period in hours assuming a 24 hour day.
`Minutes` | `toStandardMinutes()` Converts this period in days to a period in minutes assuming a 24 hour day and 60 minute hour.
`Seconds` | `toStandardSeconds()` Converts this period in days to a period in seconds assuming a 24 hour day, 60 minute hour and 60 second minute.
`Weeks` | `toStandardWeeks()` Converts this period in days to a period in weeks assuming a 7 day week.
`java.lang.String` | `toString()` Gets this instance as a String in the ISO8601 duration format.

Methods inherited from class org.joda.time.base.BaseSingleFieldPeriod
`between, between, compareTo, equals, get, getFieldType, getValue, getValue, hashCode, isSupported, setValue, size, standardPeriodIn, toMutablePeriod, toPeriod`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### ZERO

    public static final Days ZERO

  Constant representing zero days.

### ONE

    public static final Days ONE

  Constant representing one day.

### TWO

    public static final Days TWO

  Constant representing two days.

### THREE

    public static final Days THREE

  Constant representing three days.

### FOUR

    public static final Days FOUR

  Constant representing four days.

### FIVE

    public static final Days FIVE

  Constant representing five days.

### SIX

    public static final Days SIX

  Constant representing six days.

### SEVEN

    public static final Days SEVEN

  Constant representing seven days.

### MAX_VALUE

    public static final Days MAX_VALUE

  Constant representing the maximum nuber of days that can be stored in this object.

### MIN_VALUE

    public static final Days MIN_VALUE

  Constant representing the minimum nuber of days that can be stored in this object.

Method Detail

### days

    public static Days days(int days)

  Obtains an instance of `Days` that may be cached. `Days` is immutable, so instances can be cached and shared. This factory method provides access to shared instances.

  Parameters:
    `days` - the number of days to obtain an instance for
  Returns:
    the instance of Days

### daysBetween

    public static Days daysBetween(ReadableInstant start,
                                   ReadableInstant end)

  Creates a `Days` representing the number of whole days between the two specified datetimes. This method corectly handles any daylight savings time changes that may occur during the interval.

  Parameters:
    `start` - the start instant, must not be null
    `end` - the end instant, must not be null
  Returns:
    the period in days
  Throws:
    `java.lang.IllegalArgumentException` - if the instants are null or invalid

### daysBetween

    public static Days daysBetween(ReadablePartial start,
                                   ReadablePartial end)

  Creates a `Days` representing the number of whole days between the two specified partial datetimes.

  The two partials must contain the same fields, for example you can specify two `LocalDate` objects.

  Parameters:
    `start` - the start partial date, must not be null
    `end` - the end partial date, must not be null
  Returns:
    the period in days
  Throws:
    `java.lang.IllegalArgumentException` - if the partials are null or invalid

### daysIn

    public static Days daysIn(ReadableInterval interval)

  Creates a `Days` representing the number of whole days in the specified interval. This method corectly handles any daylight savings time changes that may occur during the interval.

  Parameters:
    `interval` - the interval to extract days from, null returns zero
  Returns:
    the period in days
  Throws:
    `java.lang.IllegalArgumentException` - if the partials are null or invalid

### standardDaysIn

    public static Days standardDaysIn(ReadablePeriod period)

  Creates a new `Days` representing the number of complete standard length days in the specified period.

  This factory method converts all fields from the period to hours using standardised durations for each field. Only those fields which have a precise duration in the ISO UTC chronology can be converted.

  - One week consists of 7 days.
  - One day consists of 24 hours.
  - One hour consists of 60 minutes.
  - One minute consists of 60 seconds.
  - One second consists of 1000 milliseconds.
  Months and Years are imprecise and periods containing these values cannot be converted.

  Parameters:
    `period` - the period to get the number of hours from, null returns zero
  Returns:
    the period in days
  Throws:
    `java.lang.IllegalArgumentException` - if the period contains imprecise duration values

### parseDays

    public static Days parseDays(java.lang.String periodStr)

  Creates a new `Days` by parsing a string in the ISO8601 format 'PnD'.

  The parse will accept the full ISO syntax of PnYnMnWnDTnHnMnS however only the days component may be non-zero. If any other component is non-zero, an exception will be thrown.

  Parameters:
    `periodStr` - the period string, null returns zero
  Returns:
    the period in days
  Throws:
    `java.lang.IllegalArgumentException` - if the string format is invalid

### getFieldType

    public DurationFieldType getFieldType()

  Gets the duration field type, which is `days`.

  Specified by:
    `getFieldType` in class `BaseSingleFieldPeriod`
  Returns:
    the period type

### getPeriodType

    public PeriodType getPeriodType()

  Gets the period type, which is `days`.

  Specified by:
    `getPeriodType` in interface `ReadablePeriod`
  Specified by:
    `getPeriodType` in class `BaseSingleFieldPeriod`
  Returns:
    the period type

### toStandardWeeks

    public Weeks toStandardWeeks()

  Converts this period in days to a period in weeks assuming a 7 day week.

  This method allows you to convert between different types of period. However to achieve this it makes the assumption that all weeks are 7 days long. This may not be true for some unusual chronologies. However, it is included as it is a useful operation for many applications and business rules.

  Returns:
    a period representing the number of weeks for this number of days

### toStandardHours

    public Hours toStandardHours()

  Converts this period in days to a period in hours assuming a 24 hour day.

  This method allows you to convert between different types of period. However to achieve this it makes the assumption that all days are 24 hours long. This is not true when daylight savings is considered and may also not be true for some unusual chronologies. However, it is included as it is a useful operation for many applications and business rules.

  Returns:
    a period representing the number of hours for this number of days
  Throws:
    `java.lang.ArithmeticException` - if the number of hours is too large to be represented

### toStandardMinutes

    public Minutes toStandardMinutes()

  Converts this period in days to a period in minutes assuming a 24 hour day and 60 minute hour.

  This method allows you to convert between different types of period. However to achieve this it makes the assumption that all days are 24 hours long and all hours are 60 minutes long. This is not true when daylight savings is considered and may also not be true for some unusual chronologies. However, it is included as it is a useful operation for many applications and business rules.

  Returns:
    a period representing the number of minutes for this number of days
  Throws:
    `java.lang.ArithmeticException` - if the number of minutes is too large to be represented

### toStandardSeconds

    public Seconds toStandardSeconds()

  Converts this period in days to a period in seconds assuming a 24 hour day, 60 minute hour and 60 second minute.

  This method allows you to convert between different types of period. However to achieve this it makes the assumption that all days are 24 hours long, all hours are 60 minutes long and all minutes are 60 seconds long. This is not true when daylight savings is considered and may also not be true for some unusual chronologies. However, it is included as it is a useful operation for many applications and business rules.

  Returns:
    a period representing the number of seconds for this number of days
  Throws:
    `java.lang.ArithmeticException` - if the number of seconds is too large to be represented

### toStandardDuration

    public Duration toStandardDuration()

  Converts this period in days to a duration in milliseconds assuming a 24 hour day, 60 minute hour and 60 second minute.

  This method allows you to convert from a period to a duration. However to achieve this it makes the assumption that all days are 24 hours long, all hours are 60 minutes and all minutes are 60 seconds. This is not true when daylight savings time is considered, and may also not be true for some unusual chronologies. However, it is included as it is a useful operation for many applications and business rules.

  Returns:
    a duration equivalent to this number of days

### getDays

    public int getDays()

  Gets the number of days that this period represents.

  Returns:
    the number of days in the period

### plus

    public Days plus(int days)

  Returns a new instance with the specified number of days added.

  This instance is immutable and unaffected by this method call.

  Parameters:
    `days` - the amount of days to add, may be negative
  Returns:
    the new period plus the specified number of days
  Throws:
    `java.lang.ArithmeticException` - if the result overflows an int

### plus

    public Days plus(Days days)

  Returns a new instance with the specified number of days added.

  This instance is immutable and unaffected by this method call.

  Parameters:
    `days` - the amount of days to add, may be negative, null means zero
  Returns:
    the new period plus the specified number of days
  Throws:
    `java.lang.ArithmeticException` - if the result overflows an int

### minus

    public Days minus(int days)

  Returns a new instance with the specified number of days taken away.

  This instance is immutable and unaffected by this method call.

  Parameters:
    `days` - the amount of days to take away, may be negative
  Returns:
    the new period minus the specified number of days
  Throws:
    `java.lang.ArithmeticException` - if the result overflows an int

### minus

    public Days minus(Days days)

  Returns a new instance with the specified number of days taken away.

  This instance is immutable and unaffected by this method call.

  Parameters:
    `days` - the amount of days to take away, may be negative, null means zero
  Returns:
    the new period minus the specified number of days
  Throws:
    `java.lang.ArithmeticException` - if the result overflows an int

### multipliedBy

    public Days multipliedBy(int scalar)

  Returns a new instance with the days multiplied by the specified scalar.

  This instance is immutable and unaffected by this method call.

  Parameters:
    `scalar` - the amount to multiply by, may be negative
  Returns:
    the new period multiplied by the specified scalar
  Throws:
    `java.lang.ArithmeticException` - if the result overflows an int

### dividedBy

    public Days dividedBy(int divisor)

  Returns a new instance with the days divided by the specified divisor. The calculation uses integer division, thus 3 divided by 2 is 1.

  This instance is immutable and unaffected by this method call.

  Parameters:
    `divisor` - the amount to divide by, may be negative
  Returns:
    the new period divided by the specified divisor
  Throws:
    `java.lang.ArithmeticException` - if the divisor is zero

### negated

    public Days negated()

  Returns a new instance with the days value negated.

  Returns:
    the new period with a negated value
  Throws:
    `java.lang.ArithmeticException` - if the result overflows an int

### isGreaterThan

    public boolean isGreaterThan(Days other)

  Is this days instance greater than the specified number of days.

  Parameters:
    `other` - the other period, null means zero
  Returns:
    true if this days instance is greater than the specified one

### isLessThan

    public boolean isLessThan(Days other)

  Is this days instance less than the specified number of days.

  Parameters:
    `other` - the other period, null means zero
  Returns:
    true if this days instance is less than the specified one

### toString

    public java.lang.String toString()

  Gets this instance as a String in the ISO8601 duration format.

  For example, "P4D" represents 4 days.

  Specified by:
    `toString` in interface `ReadablePeriod`
  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    the value as an ISO8601 string

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD